﻿
@using System.Web.UI.WebControls;
@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using DevExpress.Utils;
@using Toyota.Common.Web.Html;
@using Toyota.Common.Web.Html.Helper;
@Html.Common().DevExpress().GridView(
grid =>    {
    
    grid.Name = "GridPurchaseOrder";
    grid.Width = Unit.Percentage(100);
    grid.Height = Unit.Percentage(100);
    grid.Settings.ShowFilterRow = true;
    grid.Settings.ShowFilterRowMenu = true;
    grid.Settings.ShowColumnHeaders = true;

    grid.CallbackRouteValues = new { Controller = "D31201", Action = "PartialDatas" };
    grid.ClientSideEvents.BeginCallback = "OnBeginCallbackGrid";
    //grid.ClientSideEvents.Init = "function(s, e) { s.PerformCallback(); }";
    grid.SettingsBehavior.AllowSelectSingleRowOnly = false;
    grid.SettingsBehavior.AllowSelectByRowClick = true;

    grid.Settings.HorizontalScrollBarMode = ScrollBarMode.Visible;
    grid.Settings.VerticalScrollBarMode = ScrollBarMode.Hidden;
    grid.Styles.Header.HorizontalAlign = HorizontalAlign.Center;
    grid.Styles.Header.VerticalAlign = VerticalAlign.Middle;

    grid.SettingsPager.FirstPageButton.Visible = true;
    grid.SettingsPager.LastPageButton.Visible = true;
    grid.SettingsPager.ShowNumericButtons = true;
    grid.KeyFieldName = "PO_NO";
    grid.SettingsPager.Position = PagerPosition.Bottom;
    grid.SettingsPager.PageSizeItemSettings.Visible = true;
    grid.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
    grid.SettingsPager.PageSizeItemSettings.Caption = "Page size";
    
    //grid.CommandColumn.Visible = true;
    //grid.CommandColumn.Width = Unit.Pixel(40);
    //grid.CommandColumn.ClearFilterButton.Visible = true;
    //grid.CommandColumn.ShowSelectCheckbox = false;

    //grid.CommandColumn.SetHeaderTemplateContent(
    //        content =>
    //        {
    //            Html.DevExpress().CheckBox(
    //                checkBox =>
    //                {
    //                    checkBox.Name = "DeliverySelectAllCheckBox"; 
    //                    checkBox.Checked = content.Grid.Selection.Count > 1;
    //                }
    //            ).Render();
    //        });

    grid.Columns.Add(
        columnPR =>
        {
            columnPR.FieldName = "PR_NO";
            columnPR.Name = "PR_NO";
            columnPR.Caption = "PR Number";
            columnPR.Width = Unit.Pixel(100);
            columnPR.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
            columnPR.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            columnPR.CellStyle.VerticalAlign = VerticalAlign.Middle;

            columnPR.SetDataItemTemplateContent(
                content =>
                {
                    GridViewDataItemTemplateContainer c = (GridViewDataItemTemplateContainer)content;
                    Html.DevExpress().HyperLink(
                        link =>
                        {
                            link.Name = "lnkPR_NO" + content.VisibleIndex;
                            link.NavigateUrl = "javascript:void(0)";
                            link.Properties.Text = content.Text;
                            link.ClientVisible = true;
                            link.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ OnPRClick('{0}'); }}", (content as GridViewDataItemTemplateContainer).Text);

                        }).Render();
                });
        });

    grid.Columns.Add(
        column =>
        {
            column.Name = "PO_NO";
            column.FieldName = "PO_NO";
            column.Caption = "PO Number";

            column.Width = Unit.Pixel(100);
            column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            column.CellStyle.VerticalAlign = VerticalAlign.Middle;

            column.SetDataItemTemplateContent(
                content =>
                {
                    GridViewDataItemTemplateContainer c = (GridViewDataItemTemplateContainer) content;
                    if (content.Text != "&nbsp;")
                    {
                        Html.DevExpress().HyperLink(
                            link =>
                            {
                                link.Name = "lnkPO_NO" + content.VisibleIndex;
                                link.NavigateUrl = "javascript:void(0)";
                                link.Properties.Text = content.Text;
                                link.ClientVisible = true;
                                link.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ OnPOClick('{0}'); }}", (content as GridViewDataItemTemplateContainer).Text);

                            }).Render();
                    }
                });
        });

    //-------[ PR STATUS BEGIN ]--------
    grid.Columns.AddBand(
        columnBand =>
        {
            columnBand.Caption = "PR Status";
            columnBand.Name = "PR_STATUS";
            columnBand.Columns.Add(
                shpr =>
                {
                    shpr.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                    shpr.Settings.AllowAutoFilter= DefaultBoolean.False;
                    shpr.Caption = "SH";
                    shpr.Name = "PR_SH_APPROVED_DT";
                    shpr.FieldName = "PR_SH_APPROVED_DT";
                    shpr.Width = Unit.Pixel(40);
                    shpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    shpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    shpr.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                    
                    shpr.SetDataItemTemplateContent(
                        dtshpr =>
                        {
                            
                            Html.DevExpress().Image(
                                img =>
                                {
                                    img.ImageUrl ="~/Content/Images/"+ dtshpr.Text+".png"; //"~/Content/Images/Green.png";
                                    img.Properties.ImageAlign = ImageAlign.Middle;
                                }).Render();
                        });


                }
                );

            columnBand.Columns.Add(
                dphpr =>
                {
                    dphpr.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                    dphpr.Settings.AllowAutoFilter = DefaultBoolean.False;
                    dphpr.Caption = "DpH";
                    dphpr.Name = "PR_DPH_APPROVED_DT";
                    dphpr.FieldName = "PR_DPH_APPROVED_DT";
                    dphpr.Width = Unit.Pixel(40);
                    dphpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    dphpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    dphpr.CellStyle.HorizontalAlign = HorizontalAlign.Center;


                    dphpr.SetDataItemTemplateContent(
                        dtdphpr =>
                        {
                            Html.DevExpress().Image(
                                img =>
                                {
                                    img.ImageUrl = "~/Content/Images/" + dtdphpr.Text + ".png"; ;
                                    img.Properties.ImageAlign = ImageAlign.Middle;
                                }).Render();
                        });


                }
                );
            columnBand.Columns.Add(
                dhpr =>
                {
                    dhpr.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                    dhpr.Settings.AllowAutoFilter = DefaultBoolean.False;
                    dhpr.Caption = "DH";
                    dhpr.Name = "PR_DH_APPROVED_DT";
                    dhpr.FieldName = "PR_DH_APPROVED_DT";
                    dhpr.Width = Unit.Pixel(40);
                    dhpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    dhpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    dhpr.CellStyle.HorizontalAlign = HorizontalAlign.Center;

                    dhpr.SetDataItemTemplateContent(
                        dtdhpr =>
                        {
                            Html.DevExpress().Image(
                                img =>
                                {
                                    img.ImageUrl = "~/Content/Images/" + dtdhpr.Text + ".png";
                                    img.Properties.ImageAlign = ImageAlign.Middle;
                                }).Render();
                        });


                }
                );


        }
        );

    //-------------------[ PR STATUS END ]----------------------------


    //-------[ PO STATUS BEGIN ]--------
    grid.Columns.AddBand(
        columnBand =>
        {
            columnBand.Caption = "PO Status";
            columnBand.Name = "PO_NAME";     
            columnBand.Columns.Add(
                shpo =>
                {
                    shpo.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                    shpo.Settings.AllowAutoFilter = DefaultBoolean.False;
                    shpo.Caption = "SH";
                    shpo.Name = "PO_SH_APPROVED_DT";
                    shpo.FieldName = "PO_SH_APPROVED_DT";
                    shpo.Width = Unit.Pixel(40);
                    shpo.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    shpo.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    shpo.CellStyle.HorizontalAlign = HorizontalAlign.Center;

                    shpo.SetDataItemTemplateContent(
                        dtshpo =>
                        {
                            Html.DevExpress().Image(
                                img =>
                                {
                                    img.ImageUrl = "~/Content/Images/" + dtshpo.Text + ".png"; ;
                                    img.Properties.ImageAlign = ImageAlign.Middle;
                                }).Render();
                        });


                }
                );

            columnBand.Columns.Add(
                dphpo =>
                {
                    dphpo.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                    dphpo.Settings.AllowAutoFilter = DefaultBoolean.False;
                    dphpo.Caption = "DpH";
                    dphpo.Name = "PO_DPH_APPROVED_DT";
                    dphpo.FieldName = "PO_DPH_APPROVED_DT";
                    dphpo.Width = Unit.Pixel(40);
                    dphpo.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    dphpo.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    dphpo.CellStyle.HorizontalAlign = HorizontalAlign.Center;

                    dphpo.SetDataItemTemplateContent(
                        dtdphpo =>
                        {
                            Html.DevExpress().Image(
                                img =>
                                {
                                    img.ImageUrl = "~/Content/Images/" + dtdphpo.Text + ".png";
                                    img.Properties.ImageAlign = ImageAlign.Middle;
                                }).Render();
                        });


                }
                );
            columnBand.Columns.Add(
                dhpo =>
                {
                    dhpo.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                    dhpo.Settings.AllowAutoFilter = DefaultBoolean.False;
                    dhpo.Caption = "DH";
                    dhpo.Name = "PO_DH_APPROVED_DT";
                    dhpo.FieldName = "PO_DH_APPROVED_DT";
                    dhpo.Width = Unit.Pixel(40);
                    dhpo.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    dhpo.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    dhpo.CellStyle.HorizontalAlign = HorizontalAlign.Center;

                    dhpo.SetDataItemTemplateContent(
                        dtdhpo =>
                        {
                            Html.DevExpress().Image(
                                img =>
                                {
                                    img.ImageUrl = "~/Content/Images/" + dtdhpo.Text + ".png";
                                    img.Properties.ImageAlign = ImageAlign.Middle;
                                }).Render();
                        });


                }
                );


        }
        );
    //-------------------[ PO STATUS END ]----------------------------

    grid.Columns.AddBand(
        columnBand =>
        {
            columnBand.Caption = "PR Created";
            columnBand.Name = "PR_CREATED100";

            columnBand.Columns.Add(
                        shpr =>
                        {
                            shpr.Caption = "By";
                            shpr.Name = "PR_CREATED_BY";
                            shpr.FieldName = "PR_CREATED_BY";
                            shpr.Width = Unit.Pixel(140);
                            shpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                            shpr.CellStyle.HorizontalAlign = HorizontalAlign.Left;

                        }
                        );


            columnBand.Columns.Add(
                              prdate =>
                              {
                                  prdate.Name = "PR_CREATED_DT";
                                  prdate.FieldName = "PR_CREATED_DT";
                                  prdate.Caption = "Date";
                                  prdate.Width = Unit.Pixel(100);
                                  prdate.ColumnType = MVCxGridViewColumnType.DateEdit;
                                  prdate.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                                  prdate.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                                  prdate.CellStyle.VerticalAlign = VerticalAlign.Middle;
                                  prdate.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy";
                                  prdate.PropertiesEdit.NullDisplayText = "";


            });
        });

    grid.Columns.AddBand(
        columnBand =>
        {
            columnBand.Caption = "PO Created";
            columnBand.Name = "PO_CREATED100";

            columnBand.Columns.Add(
                        shpr =>
                        {
                            shpr.Caption = "By";
                            shpr.Name = "PO_CREATED_BY";
                            shpr.FieldName = "PO_CREATED_BY";
                            shpr.Width = Unit.Pixel(140);
                            shpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                            shpr.CellStyle.HorizontalAlign = HorizontalAlign.Left;

                        }
                        );

            columnBand.Columns.Add(
                    podate =>
                    {
                        podate.Name = "PO_CREATED_DT";
                        podate.FieldName = "PO_CREATED_DT";
                        podate.Caption = "Date";
                        podate.ColumnType = MVCxGridViewColumnType.DateEdit;
                        podate.Width = Unit.Pixel(100);
                        podate.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                        podate.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                        podate.ColumnType = MVCxGridViewColumnType.DateEdit;
                        podate.PropertiesEdit.NullDisplayText = "";
                        podate.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy";
                        ;

                    });
        });
    

    grid.Columns.Add(column =>
    {
        column.Name = "STATUS";
        column.Caption = "Status";
        column.FieldName = "STATUS";
        column.Width = Unit.Pixel(100);
        column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        column.CellStyle.VerticalAlign = VerticalAlign.Middle;
        column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        column.UnboundType = DevExpress.Data.UnboundColumnType.String;
    });
    grid.CustomUnboundColumnData = (sender, e) =>
    {
        if (e.Column.Name == "STATUS")
        {
            string status = (String)e.GetListSourceFieldValue("PO_STATUS");
            if (status == "NA" || status == "")
            {
                e.Value = e.GetListSourceFieldValue("PR_STATUS");
            }
            else
            {
                e.Value = e.GetListSourceFieldValue("PO_STATUS");
            }
        }
    };

    grid.Columns.AddBand(
        columnBand =>
        {
            columnBand.Caption = "Trucking";
            columnBand.Name = "PO_TRUCKING";         
            columnBand.Columns.Add(
                lopartner =>
                {
                    lopartner.Name = "LOG_PARTNER_CODE";
                    lopartner.FieldName = "LP_CD";
                    lopartner.Caption = "Code";

                    lopartner.Width = Unit.Pixel(70);
                    lopartner.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    lopartner.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                    lopartner.CellStyle.VerticalAlign = VerticalAlign.Middle;
                });
            columnBand.Columns.Add(
                lopartner =>
                {
                    lopartner.Name = "LOG_PARTNER_NAME";
                    lopartner.FieldName = "LOG_PARTNER_NAME";
                    lopartner.Caption = "Name";

                    lopartner.Width = Unit.Pixel(225);
                    lopartner.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    lopartner.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                    lopartner.CellStyle.VerticalAlign = VerticalAlign.Middle;
                });
     });
    

      
        grid.Columns.Add(
            pdf =>
            {
                pdf.Name = "PDF";
                pdf.FieldName = "PDF";
                pdf.Caption = "PDF   ";

                pdf.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                pdf.Settings.AllowAutoFilter = DefaultBoolean.False;
                pdf.Width = Unit.Pixel(50);
                pdf.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                pdf.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                pdf.CellStyle.VerticalAlign = VerticalAlign.Middle;
                pdf.UnboundType = DevExpress.Data.UnboundColumnType.String;
                pdf.SetDataItemTemplateContent(
                    content =>
                    {
                        GridViewDataItemTemplateContainer c = (GridViewDataItemTemplateContainer)content;
                        Html.DevExpress().HyperLink(
                            link =>
                            {

                                var resValue = content.ToString().Split('|');

                                Console.WriteLine(resValue[0]);
                                
                                link.Name = "lnkPDF_" + content.VisibleIndex;
                                link.NavigateUrl = "javascript:void(0)";
                                link.Properties.Text = content.Text;
                                link.ClientVisible = true;
                                link.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ DownloadAsPDF('{0}'); }}", (content as GridViewDataItemTemplateContainer).KeyValue);
                                link.Properties.ImageUrl = "~/Content/Images/" + content.Text + ".png";
                                link.Properties.Style.VerticalAlign = VerticalAlign.Middle;
                                link.Properties.Style.HorizontalAlign = HorizontalAlign.Center;


                            }).Render();

                    });
            });
    //===============================================================================================================================
    //-------[ PR STATUS BEGIN ]--------
    grid.Columns.AddBand(
        columnBand =>
        {
            columnBand.Caption = "PR Approval";
            columnBand.Name = "PR_APPROVAL";
            columnBand.Visible = false;

            columnBand.Columns.AddBand(
                space =>
                {
                    space.Caption = "SH";
                    space.Name = "SH_SPACE";
                    space.Visible = true;

                    space.Columns.Add(
                        shpr =>
                        {
                            //shpr.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                            //shpr.Settings.AllowAutoFilter = DefaultBoolean.False;
                            shpr.Caption = "By";
                            shpr.Name = "PRD_SH_APPROVED_BY";
                            shpr.FieldName = "PR_SH_APPROVED_BY2";
                            shpr.Width = Unit.Pixel(140);
                            shpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                            shpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                            shpr.CellStyle.HorizontalAlign = HorizontalAlign.Left;

                        }
                        );



                    space.Columns.Add(
                        dphpr =>
                        {
                            //dphpr.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                            //dphpr.Settings.AllowAutoFilter = DefaultBoolean.False;
                            dphpr.Caption = "Date";
                            dphpr.Name = "PRD_SH_APPROVED_DT";
                            dphpr.FieldName = "PR_SH_APPROVED_DT2";
                            dphpr.Width = Unit.Pixel(120);
                            dphpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                            dphpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                            dphpr.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            dphpr.ColumnType = MVCxGridViewColumnType.DateEdit;
                            dphpr.PropertiesEdit.NullDisplayText = "";
                            dphpr.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                            var dateEditProperties = dphpr.PropertiesEdit as DateEditProperties;
                            dateEditProperties.EditFormatString = "dd.MM.yyyy";
                            dateEditProperties.UseMaskBehavior = true;

                        });
                    
                }
                
            );

            columnBand.Columns.AddBand(
               space2 =>
               {
                   space2.Caption = "DpH";
                   space2.Name = "DpH_SPACE";
                   space2.Visible = true;


                   space2.Columns.Add(
                       shpr =>
                       {
                           //shpr.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                           //shpr.Settings.AllowAutoFilter = DefaultBoolean.False;
                           shpr.Caption = "By";
                           shpr.Name = "PRD_DPH_APPROVED_BY";
                           shpr.FieldName = "PR_DPH_APPROVED_BY2";
                           shpr.Width = Unit.Pixel(140);
                           shpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                           shpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                           shpr.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                           //shpr.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy";
                       }
                       );

                   space2.Columns.Add(
                       dphpr =>
                       {
                           //dphpr.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                           //dphpr.Settings.AllowAutoFilter = DefaultBoolean.False;
                           dphpr.Caption = "Date";
                           dphpr.Name = "PRD_DPH_APPROVED_DT";
                           dphpr.FieldName = "PR_DPH_APPROVED_DT2";
                           dphpr.Width = Unit.Pixel(120);
                           dphpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                           dphpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                           dphpr.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                           dphpr.ColumnType = MVCxGridViewColumnType.DateEdit;
                           dphpr.PropertiesEdit.NullDisplayText = "";
                           dphpr.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";

                       });
                   
               });

            columnBand.Columns.AddBand(
               space3 =>
               {
                   space3.Caption = "DH";
                   space3.Name = "DH_SPACE";
                   space3.Visible = true;


                   space3.Columns.Add(
                       shpr =>
                       {
                           //shpr.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                           //shpr.Settings.AllowAutoFilter = DefaultBoolean.False;
                           shpr.Caption = "By";
                           shpr.Name = "PRD_DH_APPROVED_BY";
                           shpr.FieldName = "PR_DH_APPROVED_BY2";
                           shpr.Width = Unit.Pixel(140);
                           shpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                           shpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                           shpr.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                       }
                       );

                   space3.Columns.Add(
                       dphpr =>
                       {
                           //dphpr.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                           //dphpr.Settings.AllowAutoFilter = DefaultBoolean.False;
                           dphpr.Caption = "Date";
                           dphpr.Name = "PR_DH_APPROVED_DT";
                           dphpr.FieldName = "PR_DH_APPROVED_DT2";
                           dphpr.Width = Unit.Pixel(120);
                           dphpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                           dphpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                           dphpr.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                           dphpr.ColumnType = MVCxGridViewColumnType.DateEdit;
                           dphpr.PropertiesEdit.NullDisplayText = "";
                           dphpr.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";

                       });

                   
               });
        }
        );
    //-------------------[ PR STATUS END ]----------------------------

    //-------[ PR STATUS BEGIN ]--------
    grid.Columns.AddBand(
        columnBand =>
        {
            columnBand.Caption = "PO Approval";
            columnBand.Visible = false;
            columnBand.Name = "PO_APPROVAL";

            columnBand.Columns.AddBand(
               space4 =>
               {
                   space4.Caption = "SH";
                   space4.Name = "SH_SPACE_PO";
                   space4.Visible = true;


                   space4.Columns.Add(
                       shpr =>
                       {
                           //shpr.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                           //shpr.Settings.AllowAutoFilter = DefaultBoolean.False;
                           shpr.Caption = "By";
                           shpr.Name = "POD_SH_APPROVED_BY";
                           shpr.FieldName = "PO_SH_APPROVED_BY2";
                           shpr.Width = Unit.Pixel(140);
                           shpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                           shpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                           shpr.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                       }
                       );

                   space4.Columns.Add(
                       dphpr =>
                       {
                           //dphpr.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                           //dphpr.Settings.AllowAutoFilter = DefaultBoolean.False;
                           dphpr.Caption = "Date";
                           dphpr.Name = "POD_SH_APPROVED_DT";
                           dphpr.FieldName = "PO_SH_APPROVED_DT2";
                           dphpr.Width = Unit.Pixel(120);
                           dphpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                           dphpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                           dphpr.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                           dphpr.ColumnType = MVCxGridViewColumnType.DateEdit;
                           dphpr.PropertiesEdit.NullDisplayText = "";
                           dphpr.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";

                       });
                   
               });

            columnBand.Columns.AddBand(
               space5 =>
               {
                   space5.Caption = "DpH";
                   space5.Name = "DpH_SPACE_PO";
                   space5.Visible = true;


                   space5.Columns.Add(
                       shpr =>
                       {
                           //shpr.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                           //shpr.Settings.AllowAutoFilter = DefaultBoolean.False;
                           shpr.Caption = "By";
                           shpr.Name = "POD_DPH_APPROVED_BY";
                           shpr.FieldName = "PO_DPH_APPROVED_BY2";
                           shpr.Width = Unit.Pixel(140);
                           shpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                           shpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                           shpr.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                           shpr.ColumnType = MVCxGridViewColumnType.DateEdit;
                           shpr.PropertiesEdit.NullDisplayText = "";

                       }
                       );

                   space5.Columns.Add(
                       dphpr =>
                       {
                           //dphpr.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                           //dphpr.Settings.AllowAutoFilter = DefaultBoolean.False;
                           dphpr.Caption = "Date";
                           dphpr.Name = "POD_DPH_APPROVED_DT";
                           dphpr.FieldName = "PO_DPH_APPROVED_DT2";
                           dphpr.Width = Unit.Pixel(120);
                           dphpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                           dphpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                           dphpr.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                           dphpr.ColumnType = MVCxGridViewColumnType.DateEdit;
                           dphpr.PropertiesEdit.NullDisplayText = "";
                           dphpr.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";

                       });
               });

            columnBand.Columns.AddBand(
               space6 =>
               {
                   space6.Caption = "DH";
                   space6.Name = "DH_SPACE_PO";
                   space6.Visible = true;


                   space6.Columns.Add(
                       shpr =>
                       {
                           //shpr.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                           //shpr.Settings.AllowAutoFilter = DefaultBoolean.False;
                           shpr.Caption = "By";
                           shpr.Name = "POD_DH_APPROVED_BY";
                           shpr.FieldName = "PO_DH_APPROVED_BY2";
                           shpr.Width = Unit.Pixel(140);
                           shpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                           shpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                           shpr.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                           shpr.ColumnType = MVCxGridViewColumnType.DateEdit;
                           shpr.PropertiesEdit.NullDisplayText = "";

                       }
                       );

                   space6.Columns.Add(
                       dphpr =>
                       {
                           //dphpr.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                           //dphpr.Settings.AllowAutoFilter = DefaultBoolean.False;
                           dphpr.Caption = "Date";
                           dphpr.Name = "POD_DH_APPROVED_DT";
                           dphpr.FieldName = "PO_DH_APPROVED_DT2";
                           dphpr.Width = Unit.Pixel(120);
                           dphpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                           dphpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                           dphpr.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                           dphpr.ColumnType = MVCxGridViewColumnType.DateEdit;
                           dphpr.PropertiesEdit.NullDisplayText = "";
                           dphpr.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";

                       });

                   
               });
            
        }
        );

    grid.Columns.AddBand(
        columnBand =>
        {
            columnBand.Caption = "PR Rejection";
            columnBand.Visible = false;
            columnBand.Name = "PR_REJECT";
            columnBand.Columns.Add(
                shpr =>
                {
                    shpr.Caption = "By";
                    shpr.Name = "PR_REJECTED_BY";
                    shpr.FieldName = "PR_REJECTED_BY";
                    shpr.Width = Unit.Pixel(140);
                    shpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    shpr.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                    shpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    shpr.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                });
            columnBand.Columns.Add(
                pos =>
                {
                    pos.Caption = "Position";
                    pos.Name = "PR_REJECTED_POSITION";
                    pos.FieldName = "PR_REJECTED_POSITION";
                    pos.Width = Unit.Pixel(100);
                    pos.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    pos.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                    pos.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    pos.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                });

            columnBand.Columns.Add(
                dphpr =>
                {
                    dphpr.Caption = "Date";
                    dphpr.Name = "PR_REJECTED_DT";
                    dphpr.FieldName = "PR_REJECTED_DT";

                    dphpr.ColumnType = MVCxGridViewColumnType.DateEdit;
                    dphpr.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                    var dateEditProperties = dphpr.PropertiesEdit as DateEditProperties;
                    dateEditProperties.EditFormat = EditFormat.DateTime;
                    dateEditProperties.EditFormatString = "dd.MM.yyyy";
                    dateEditProperties.UseMaskBehavior = true;

                    dphpr.Width = Unit.Pixel(130);
                    dphpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    dphpr.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                    dphpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    dphpr.Settings.AutoFilterCondition = AutoFilterCondition.Equals;

                });



        }
        );

    grid.Columns.AddBand(
    columnBand =>
    {
        columnBand.Caption = "PO Rejection";
        columnBand.Name = "PO_REJECT";
        columnBand.Visible = false;
        
        columnBand.Columns.Add(
            shpr =>
            {
                shpr.Caption = "By";
                shpr.Name = "PO_REJECTED_BY";
                shpr.FieldName = "PO_REJECTED_BY";
                shpr.Width = Unit.Pixel(140);
                shpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                shpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                shpr.CellStyle.HorizontalAlign = HorizontalAlign.Left;

            }
            );

        columnBand.Columns.Add(
        pos =>
        {
            pos.Caption = "Position";
            pos.Name = "PO_REJECTED_POSITION";
            pos.FieldName = "PO_REJECTED_POSITION";
            pos.Width = Unit.Pixel(100);
            pos.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
            pos.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            pos.CellStyle.VerticalAlign = VerticalAlign.Middle;
            pos.Settings.AutoFilterCondition = AutoFilterCondition.Contains;



        });

        columnBand.Columns.Add(
            dphpr =>
            {
                dphpr.Caption = "Date";
                dphpr.Name = "PO_REJECTED_DT";
                dphpr.FieldName = "PO_REJECTED_DT";
                dphpr.Width = Unit.Pixel(120);
                dphpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                dphpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                dphpr.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                dphpr.ColumnType = MVCxGridViewColumnType.DateEdit;
                dphpr.PropertiesEdit.NullDisplayText = "";
                dphpr.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                var dateEditProperties = dphpr.PropertiesEdit as DateEditProperties;
                dateEditProperties.EditFormatString = "dd.MM.yyyy";
                dateEditProperties.UseMaskBehavior = true;


            });
    }
    );

}).Bind(Model.GetModel<Portal.Models.Delivery.PurchaseOrder.PurchaseOrderModel>().PurchaseOrderDatas).GetHtml()
  

                    
                     